# ncurses 6.1 - patch 20181117 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.1 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.1 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.1
#	http://invisible-mirror.net/archives/ncurses/6.1 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.1/ncurses-6.1-20181117.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Nov 18 00:22:59 UTC 2018
# ------------------------------------------------------------------------------
# NEWS                             |    8 +++++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# ncurses/tinfo/read_entry.c       |    7 +++++--
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# package/ncursest.spec            |    2 +-
# progs/toe.c                      |   13 ++++++++-----
# 12 files changed, 34 insertions(+), 22 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.3211 
--- ncurses-6.1-20181110+/NEWS	2018-11-11 01:36:45.000000000 +0000
+++ ncurses-6.1-20181117/NEWS	2018-11-17 22:45:23.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.3211 2018/11/11 01:36:45 tom Exp $
+-- $Id: NEWS,v 1.3214 2018/11/17 22:45:23 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,12 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20181117
+	+ ignore the hex/b64 $TERMINFO in toe's listing.
+	+ correct a status-check in _nc_read_tic_entry() so that if reading
+	  a hex/b64 $TERMINFO, and the $TERM does not match, fall-through to
+	  the compiled-in search list.
+
 20181110
 	+ several workarounds to ensure proper C compiler used in parts of
 	  Ada95 tree.
Index: VERSION
--- ncurses-6.1-20181110+/VERSION	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/VERSION	2018-11-17 15:41:00.000000000 +0000
@@ -1 +1 @@
-5:0:10	6.1	20181110
+5:0:10	6.1	20181117
Index: dist.mk
Prereq:  1.1250 
--- ncurses-6.1-20181110+/dist.mk	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/dist.mk	2018-11-17 15:41:00.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1250 2018/11/10 17:09:13 tom Exp $
+# $Id: dist.mk,v 1.1251 2018/11/17 15:41:00 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 1
-NCURSES_PATCH = 20181110
+NCURSES_PATCH = 20181117
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/tinfo/read_entry.c
Prereq:  1.148 
--- ncurses-6.1-20181110+/ncurses/tinfo/read_entry.c	2018-04-14 17:43:37.000000000 +0000
+++ ncurses-6.1-20181117/ncurses/tinfo/read_entry.c	2018-11-17 21:40:10.000000000 +0000
@@ -41,7 +41,7 @@
 
 #include <tic.h>
 
-MODULE_ID("$Id: read_entry.c,v 1.148 2018/04/14 17:43:37 tom Exp $")
+MODULE_ID("$Id: read_entry.c,v 1.150 2018/11/17 21:40:10 tom Exp $")
 
 #define TYPE_CALLOC(type,elts) typeCalloc(type, (unsigned)(elts))
 
@@ -749,10 +749,13 @@
        (T_CALLED("_nc_read_tic_entry(file=%p, path=%s, name=%s)"),
 	filename, path, name));
 
+    assert(TGETENT_YES == TRUE);	/* simplify call for _nc_name_match */
+
     if ((used = decode_quickdump(buffer, path)) != 0
 	&& (code = _nc_read_termtype(tp, buffer, used)) == TGETENT_YES
-	&& _nc_name_match(tp->term_names, name, "|")) {
+	&& (code = _nc_name_match(tp->term_names, name, "|")) == TGETENT_YES) {
 	TR(TRACE_DATABASE, ("loaded quick-dump for %s", name));
+	strcpy(filename, "$TERMINFO");	/* shorten name shown by infocmp */
     } else
 #if USE_HASHED_DB
 	if (make_db_filename(filename, limit, path)
Index: package/debian-mingw/changelog
--- ncurses-6.1-20181110+/package/debian-mingw/changelog	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/debian-mingw/changelog	2018-11-17 15:41:00.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181110) unstable; urgency=low
+ncurses6 (6.1+20181117) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Nov 2018 12:09:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 17 Nov 2018 10:41:00 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.1-20181110+/package/debian-mingw64/changelog	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/debian-mingw64/changelog	2018-11-17 15:41:00.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181110) unstable; urgency=low
+ncurses6 (6.1+20181117) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Nov 2018 12:09:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 17 Nov 2018 10:41:00 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.1-20181110+/package/debian/changelog	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/debian/changelog	2018-11-17 15:41:00.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181110) unstable; urgency=low
+ncurses6 (6.1+20181117) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Nov 2018 12:09:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 17 Nov 2018 10:41:00 -0500
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.297 
--- ncurses-6.1-20181110+/package/mingw-ncurses.nsi	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/mingw-ncurses.nsi	2018-11-17 15:41:00.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.297 2018/11/10 17:09:13 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.298 2018/11/17 15:41:00 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "1"
 !define VERSION_YYYY  "2018"
-!define VERSION_MMDD  "1110"
+!define VERSION_MMDD  "1117"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.1-20181110+/package/mingw-ncurses.spec	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/mingw-ncurses.spec	2018-11-17 15:41:00.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.1
-Release: 20181110
+Release: 20181117
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.1-20181110+/package/ncurses.spec	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/ncurses.spec	2018-11-17 15:41:00.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.1
-Release: 20181110
+Release: 20181117
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncursest.spec
--- ncurses-6.1-20181110+/package/ncursest.spec	2018-11-10 17:09:13.000000000 +0000
+++ ncurses-6.1-20181117/package/ncursest.spec	2018-11-17 15:41:00.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: Curses library with POSIX thread support.
 Name: ncursest6
 Version: 6.1
-Release: 20181110
+Release: 20181117
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: progs/toe.c
Prereq:  1.77 
--- ncurses-6.1-20181110+/progs/toe.c	2017-12-23 19:23:40.000000000 +0000
+++ ncurses-6.1-20181117/progs/toe.c	2018-11-17 22:41:46.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2013,2017 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -44,7 +44,7 @@
 #include <hashed_db.h>
 #endif
 
-MODULE_ID("$Id: toe.c,v 1.77 2017/12/23 19:23:40 tom Exp $")
+MODULE_ID("$Id: toe.c,v 1.78 2018/11/17 22:41:46 tom Exp $")
 
 #define isDotname(name) (!strcmp(name, ".") || !strcmp(name, ".."))
 
@@ -497,8 +497,8 @@
 		}
 	    }
 	}
-#endif
-#endif
+#endif /* USE_HASHED_DB */
+#endif /* NCURSES_USE_DATABASE */
 #if NCURSES_USE_TERMCAP
 #if HAVE_BSD_CGETENT
 	{
@@ -700,6 +700,8 @@
 
 	    _nc_first_db(&state, &offset);
 	    while ((path = _nc_next_db(&state, &offset)) != 0) {
+		if (quick_prefix(path))
+		    continue;
 		if (pass) {
 		    eargv[count] = strmalloc(path);
 		}
@@ -725,7 +727,8 @@
 	    failed("eargv");
 	_nc_first_db(&state, &offset);
 	if ((path = _nc_next_db(&state, &offset)) != 0) {
-	    eargv[count++] = strmalloc(path);
+	    if (!quick_prefix(path))
+		eargv[count++] = strmalloc(path);
 	}
 
 	code = typelist((int) count, eargv, header, hook);
